diff -urN versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/fiscnet/FiscNetECF.py trunk/stoqdrivers/printers/fiscnet/FiscNetECF.py
--- versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/fiscnet/FiscNetECF.py	2016-12-29 14:30:59.000000000 -0200
+++ trunk/stoqdrivers/printers/fiscnet/FiscNetECF.py	2017-01-23 16:54:44.641415359 -0200
@@ -34,16 +34,18 @@
 
 from serial import PARITY_EVEN
 from zope.interface import implements
+from sigpdv.tools.config import config
 
 from kiwi.datatypes import currency
 from kiwi.python import Settable
 
+from stoqdrivers.logs.log import traced as log
 from stoqdrivers.enum import PaymentMethodType, TaxType, UnitType
 from stoqdrivers.exceptions import (DriverError, PendingReduceZ,
     CommandParametersError, CommandError, ReadXError, OutofPaperError,
-    CouponTotalizeError, PaymentAdditionError, CancelItemError,
+    CouponTotalizeError, PaymentAdditionError, CancelItemError, SummerTime,
     CouponOpenError, InvalidState, PendingReadX, CloseCouponError,
-    CouponNotOpenError)
+    CouponNotOpenError, PrinterOfflineError, BlockZ)
 from stoqdrivers.interfaces import ICouponPrinter, IChequePrinter
 from stoqdrivers.printers.capabilities import Capability
 from stoqdrivers.printers.cheque import BaseChequePrinter, BankConfiguration
@@ -88,6 +90,9 @@
     FLAG_MFD_ESGOTADA: 'FLAG_MFD_ESGOTADA',
     }
 
+TWOPLACES = Decimal(10) ** -2
+TREPLACES = Decimal(10) ** -3
+
 
 class FiscNetConstants(BaseDriverConstants):
     _constants = {
@@ -126,7 +131,7 @@
     identify_customer_at_end = False
 
 
-    CHEQUE_CONFIGFILE = 'perto.ini'
+    CHEQUE_CONFIGFILE = 'elgin.ini'
 
     CMD_PREFIX = '{'
     CMD_SUFFIX = '}'
@@ -140,10 +145,13 @@
         8013: CouponTotalizeError,
         8014: PaymentAdditionError,
         8017: CloseCouponError,
+        8023: SummerTime,
+        8024: SummerTime,
         8044: CancelItemError,
         8045: CancelItemError,
         8068: PaymentAdditionError,
         8086: CancelItemError,
+
         15009: PendingReduceZ,
         11002: CommandParametersError,
         11006: CommandError,
@@ -154,7 +162,8 @@
         }
 
     def __init__(self, port, consts=None):
-        port.set_options(baudrate=115200, parity=PARITY_EVEN)
+        port.set_options(baudrate=115200, parity=PARITY_EVEN,
+                         write_timeout=3, read_timeout=3)
         SerialBase.__init__(self, port)
         self._consts = consts or FiscNetConstants
         self._command_id = 0
@@ -186,7 +195,8 @@
                 if m:  # quoted value
                     text = unmatched(m)
                     value = m.group(1)
-                    value = _RETVAL_ESCAPE_RE.sub(r"\1", value)
+                    t = r"\1"
+                    value = _RETVAL_ESCAPE_RE.sub(t, value)
                 else:
                     m = _RETVAL_VALUE_RE.search(text)
                     if m:  # unquoted value
@@ -204,6 +214,8 @@
 
     def _send_command(self, command, **params):
         # Page 38-39
+        if command == 1:
+            return self.get_status(1)
         parameters = []
         for param, value in params.items():
             if isinstance(value, Decimal):
@@ -220,18 +232,40 @@
 
             parameters.append('%s=%s' % (param, value))
 
-        reply = self.writeline("%d;%s;%s;" % (self._command_id,
-                                              command,
-                                              ' '.join(parameters)))
+        try:
+            reply = self.writeline("%d;%s;%s;" % (self._command_id,
+                                                  command,
+                                                  ' '.join(parameters)))
+        except Exception as e:
+            if e.message == 'Timeout' and command == 'EmiteReducaoZ':
+                limite = 1
+                # tratamento para o caso da redução Z demorar muito a emitir o cupom na ECF
+                while True:
+                    try:
+                        reply = self._get_status()
+                        if reply or limite > 25:
+                            return True
+
+                    except Exception as e:
+                        log.error("Lendo reducao Z: %s" % str(e))
+                        if limite > 10:
+                            return False
+
+                    limite += 1
+
+            else:
+                raise e
+
         if reply[0] != '{':
             # This happened once after the first command issued after
             # the power returned, it should probably be handled gracefully
             raise AssertionError(repr(reply))
 
         # Page 39
+        
         sections = reply[1:].split(';')
         if len(sections) != 4:
-            raise AssertionError
+            raise AssertionError('Erro ao obter resposta do ECF')
 
         retdict = self._parse_return_value(sections[2])
         errorcode = int(sections[1])
@@ -259,6 +293,11 @@
             cmd = 'LeData'
             argname = 'NomeData'
             retname = 'ValorData'
+        elif regtype == datetime.time:
+            cmd = 'LeHora'
+            argname = 'NomeHora'
+            retname = 'ValorHora'
+            
         elif regtype == str:
             cmd = 'LeTexto'
             argname = 'NomeTexto'
@@ -279,27 +318,245 @@
         elif regtype == datetime.date:
             # This happens the first time we send a ReducaoZ after
             # opening the printer and removing the jumper.
-            if retval == '#00/00/0000#':
-                return datetime.date.today()
-            else:
-                # "29/03/2007" -> datetime.date(2007, 3, 29)
-                d, m, y = map(int, retval[1:-1].split('/'))
-                return datetime.date(y, m, d)
+#            if retval == '#00/00/0000#':
+#                return datetime.date.today()
+#            else:
+            # "29/03/2007" -> datetime.date(2007, 3, 29)
+            d, m, y = map(int, retval[1:-1].split('/'))
+            return datetime.date(y, m, d)
+        elif regtype == datetime.time:
+#            if retval == '#00:00:00#':
+#                return datetime.datetime.date.today().time()
+#            else:
+            h, m, s = map(int, retval[1:-1].split(':'))
+            return datetime.time(h, m, s)
         elif regtype == str:
             # '"string"' -> 'string'
             return retval.strip('"')
         else:
             raise AssertionError
+    class FiscNetStatus(object):
+        codes = {
+            128: (OutofPaperError(_("Impressora sem papel"))),
+            8: (CommandError(_("First data value in CMD is not ESC (1BH)"))),
+            4: (CommandError(_("Nonexistent command"))),
+            2: (CouponOpenError(_("Printer has a coupon currently open"))),
+            1: (CommandError(_("Invalid number of parameters")))}
+
+        def __init__(self, reply, parent):
+            self.reply = reply
+            self.codes = reply
+            self.cls = parent
+
+        @property
+        def open(self):
+            st = bool(self.reply & FLAG_DOCUMENTO_ABERTO)
+            return st
+        @property
+        def pagamento_existe(self):
+            return bool(self.reply & FLAG_Z_PENDENTE)
+        @property
+        def out_paper(self):
+            retcmd = self.cls._send_command('LeIndicador', NomeIndicador="SensorPoucoPapel")
+            retcmd = retcmd.get('ValorNumericoIndicador')
+            return bool(int(retcmd))
+        @property
+        def block_z(self):
+            return bool(self.reply & FLAG_Z_PENDENTE)
+
+        @property
+        def off_line(self):
+            st = bool(self.reply & FLAG_EM_LINHA)
+            if st:
+                st = False
+            else:
+                st = True
+            return st
+
+        def check_error(self):
+#            errors_dict = {
+#                7003: OutofPaperError,
+#                7004: OutofPaperError,
+#                8007: CouponTotalizeError,
+#                8011: PaymentAdditionError,
+#                8013: CouponTotalizeError,
+#                8014: PaymentAdditionError,
+#                8017: CloseCouponError,
+#                8044: CancelItemError,
+#                8045: CancelItemError,
+#                8068: PaymentAdditionError,
+#                8086: CancelItemError,
+#                15009: PendingReduceZ,
+#                11002: CommandParametersError,
+#                11006: CommandError,
+#                11007: InvalidState,
+#                15007: PendingReadX,
+#                15008: ReadXError,
+#                15011: OutofPaperError
+#                }
+            flags_check = { FLAG_INTERVENCAO_TECNICA: InvalidState('Equipamento em Intervenção Técnica.'),
+                            FLAG_SEM_MFD: DriverError('MFD não encontrada.'),
+                            FLAG_RAM_NOK: DriverError('RAM não está consistente.'),
+                            FLAG_RELOGIO_NOK: DriverError('Relógio inconsistente.'),
+                            FLAG_SEM_MF: DriverError('Memória fiscal não encontrada.'),
+                            FLAG_DIA_FECHADO: BlockZ('Bloqueio por Redução Z.'),
+                            FLAG_Z_PENDENTE: PendingReduceZ('Redução Z pendente.'),
+                            FLAG_SEM_PAPEL: OutofPaperError('Sem papel na estação de cupom fiscal.'),
+                            FLAG_MECANISM_NOK: DriverError('Mecanismo impressor não configurado.'),
+                            FLAG_MFD_ESGOTADA: DriverError('MFD Esgotada.')}
+
+            for i in sorted(flags_check.keys()):
+                if i & self.reply:
+                    
+                    raise flags_check[i]
+
+        def check_error_two(self):
+            return True
+
+
+    def get_status(self, val=None, cmd_status=None):
+        status = self._get_status()
+        return self.FiscNetStatus(status, parent=self)
+        
+        lst_status = []
+        #return status 
+        if status & FLAG_INTERVENCAO_TECNICA:
+            lst_status.append(FLAG_INTERVENCAO_TECNICA)
+
+        if status & FLAG_RAM_NOK:
+            lst_status.append(FLAG_RAM_NOK)
+
+        if status & FLAG_RELOGIO_NOK:
+            lst_status.append(FLAG_RELOGIO_NOK)
+
+        if status & FLAG_SEM_MF:
+            lst_status.append(FLAG_SEM_MF)
+
+        if status & FLAG_DIA_FECHADO:
+            lst_status.append(FLAG_DIA_FECHADO)
+
+        if status & FLAG_DIA_ABERTO:
+            lst_status.append(FLAG_DIA_ABERTO)
+
+        if status & FLAG_Z_PENDENTE:
+            lst_status.append(FLAG_Z_PENDENTE)
+
+        if status & FLAG_SEM_PAPEL:
+            lst_status.append(FLAG_SEM_PAPEL)
+        
+        if status & FLAG_MECANISM_NOK:
+            lst_status.append(FLAG_MECANISM_NOK)
+        
+        if status & FLAG_DOCUMENTO_ABERTO:
+            lst_status.append(FLAG_DOCUMENTO_ABERTO)
+        
+        if status & FLAG_INSCRICOES_OK:
+            lst_status.append(FLAG_INSCRICOES_OK)
+        
+        if status & FLAG_EM_LINHA:
+            lst_status.append(FLAG_EM_LINHA)
+        else:
+            raise PrinterOfflineError(u'Impressora Off-Line')
+
+        if status & FLAG_MFD_ESGOTADA:
+            print 'FLAG_MFD_ESGOTADA', FLAG_MFD_ESGOTADA        
+
+        return lst_status
+
+    def set_summertime(self, value=None):
+        return self._send_command('AcertaHorarioVerao')
+
+    def get_summertime(self):
+        retval = self._send_command('LeIndicador', NomeIndicador="HorarioVerao")
+        status = retval.get('ValorNumericoIndicador', '0')
+        return bool(int(status))
+
+    
+
+    def get_ecf_date(self):
+        d = self._read_register('Data', datetime.date)
+        h = self._read_register('Hora', datetime.time)
+        return datetime.datetime(d.year, d.month, d.day, h.hour, h.minute, h.second)
+
+    def get_data_mov(self):
+        return self._read_register('DataAbertura', datetime.date)
+    
+    def open_cash_drawer(self, sec=0):
+        return self._send_command('AbreGaveta', TempoAcionamentoGaveta=sec)
+
+    def get_corta_papel(self, corte=1):
+        if config['cortapapel']:
+            try:
+                self._send_command('CortaPapel', TipoCorte=corte)
+                return True
+            except Exception as e:
+                log.error("Erro ao cortar papel: %s" % str(e))
+
+        return False
+
+    def get_status_cash_drawer(self):
+        retval = self._send_command('LeIndicador', NomeIndicador="SensorGaveta")
+        status = retval.get('ValorNumericoIndicador', False)
+        return bool(int(status))
 
     def _get_status(self):
         return self._read_register('Indicadores', int)
 
     def _get_last_item_id(self):
-        return self._read_register('ContadorDocUltimoItemVendido', int)
+        try:
+            res = self._read_register('ContadorDocUltimoItemVendido', int)
+        except Exception as e:
+            log.error(str(e))
+            res = 999
+
+        return res
 
+    def _get_coupon_subtotal(self):
+        return self._get_coupon_total_value()
+    
     def _get_coupon_total_value(self):
         return self._read_register('TotalDocLiquido', Decimal)
 
+    def _emite_leitura_fita_detalhe(self, *args, **kwargs):
+        COOFinal = args[1].get('COOFinal')
+        COOInicial = args[1].get('COOInicial')
+        DataFinal = False
+        DataInicial = False
+        if args[1].get('yf') and args[1].get('mf') and args[1].get('df'):
+            DataFinal = datetime.date(args[1].get('yf'), args[1].get('mf'), args[1].get('df'))
+            DataInicial = datetime.date(args[1].get('yi'), args[1].get('mi'), args[1].get('di'))
+        Destino = args[1].get('Destino')
+        Proprietario = args[1].get('Proprietario')
+        TipoDocumento = args[1].get('TipoDocumento')
+        if COOFinal: # consulta por coo
+            if Destino == 'I': # impressora
+                res = self._send_command('EmiteLeituraFitaDetalhe', COOFinal=COOFinal, COOInicial=COOInicial,
+                                         Destino=Destino)
+            else: # Recepcao Serial
+                res = self._send_command('EmiteLeituraFitaDetalhe', COOFinal=COOFinal, COOInicial=COOInicial,
+                                         Destino=Destino, TipoDocumento=TipoDocumento)
+        else: # consulta por data
+            if Destino == 'I': # impressora
+                res = self._send_command('EmiteLeituraFitaDetalhe', DataFinal=DataFinal, DataInicial=DataInicial,
+                                         Destino=Destino)
+            else: # Recepcao Serial
+                res = self._send_command('EmiteLeituraFitaDetalhe', DataFinal=DataFinal, DataInicial=DataInicial,
+                                         Destino=Destino, TipoDocumento=TipoDocumento)
+        return self._le_impressao()
+
+    def _le_impressao(self):
+        '''
+        (TextoImpressao) Le os ultimos 4000 caracters nao lidos impressos da impressora
+        :return: dicionario de chave 'TextoImpressao' e o valor a string da leitura
+        '''
+        res = texto = self._send_command('LeImpressao').get('TextoImpressao')
+        # enquanto houver texto a ser lido, chama a funcao le_impressao()
+        while texto:
+            texto = self._send_command('LeImpressao').get('TextoImpressao')
+            res += texto
+
+        return res.decode('cp850')
+
     def _get_coupon_remainder_value(self):
         value = self._read_register('TotalDocValorPago', Decimal)
         result = self._get_coupon_total_value() - value
@@ -340,7 +597,7 @@
             if e.code != 8057: # Not configured
                 raise
 
-    def _define_payment_method(self, code, name):
+    def _define_payment_method(self, code, name, vinculated=False):
         try:
             retdict = self._send_command(
                 'LeMeioPagamento', CodMeioPagamentoProgram=code)
@@ -361,7 +618,7 @@
             self._send_command(
                 'DefineMeioPagamento',
                 CodMeioPagamentoProgram=code, DescricaoMeioPagamento=name,
-                NomeMeioPagamento=name, PermiteVinculado=False)
+                NomeMeioPagamento=name, PermiteVinculado=vinculated)
         except DriverError, e:
             raise
 
@@ -407,6 +664,8 @@
         except DriverError, e:
             if e.code != 8005: # Not configured
                 raise
+    def get_tax(self):
+        return self._get_taxes()
 
     def _get_taxes(self):
         taxes = []
@@ -418,6 +677,7 @@
 
         read_r = lambda x: self._read_register(x, Decimal)
 
+
         taxes = [
             ('I', read_r('TotalDiaIsencaoICMS'), 'ICMS'),
             ('F', read_r('TotalDiaSubstituicaoTributariaICMS'), 'ICMS'),
@@ -428,6 +688,7 @@
 
         for reg in range(16):
             value = read_r('TotalDiaValorAliquota[%d]' % reg)
+
             if value:
                 retdict = self._send_command(
                     'LeAliquota', CodAliquotaProgramavel=reg)
@@ -441,6 +702,44 @@
                 taxes.append(('%04d' % int(desc), value, type))
         return taxes
 
+    def get_totalizadores(self, total=False):
+        '''
+        Esta funcao busca cada totalizador da ecf e seus valores
+        '''
+        taxes = []
+        taxes.append(('CANC', Decimal(0), 'ICMS'))
+        taxes.append(('DESC', Decimal(0), 'ICMS'))
+        taxes.append(('I', Decimal(0), 'ICMS'))
+        taxes.append(('N', Decimal(0), 'ICMS'))
+        taxes.append(('F', Decimal(0), 'ICMS'))
+
+        read_r = lambda x: self._read_register(x, Decimal)
+
+        taxes = [
+            ('I', read_r('TotalDiaIsencaoICMS'), 'ICMS'),
+            ('F', read_r('TotalDiaSubstituicaoTributariaICMS'), 'ICMS'),
+            ('N', read_r('TotalDiaNaoTributadoICMS'), 'ICMS'),
+            ('DESC', read_r('TotalDiaDescontos'), 'ICMS'),
+            ('ACRESC', read_r('TotalDiaAcrescimos'), 'ICMS'),
+            ('CANC', read_r('TotalDiaCancelamentosICMS'), 'ICMS'),
+            ('CANC', read_r('TotalDiaCancelamentosISSQN'), 'ISS'),
+            ]
+
+        for reg in range(16):
+            value = read_r('TotalDiaValorAliquota[%d]' % (reg+1))
+            try:
+                retdict = self._send_command('LeAliquota', CodAliquotaProgramavel=reg+1)
+
+                if retdict['AliquotaICMS'] == 'Y':
+                    type = "ICMS"
+                else:
+                    type = "ISS"
+
+                taxes.append(('%02d' % (reg+1), value, type))
+            except: # para um numero de CodAliquotaProgramavel que nao esta cadastrado na ecf encerra a repeticao
+                break
+        return taxes
+
     def setup(self):
         self._define_tax_name(0, "Suprimento".encode('cp850'))
         self._define_tax_name(1, "Sangria".encode('cp850'))
@@ -449,8 +748,10 @@
 
         self._define_payment_method(0, u'Cheque'.encode('cp850'))
         self._define_payment_method(1, u'Boleto'.encode('cp850'))
-        self._define_payment_method(2, u'Cartão credito'.encode('cp850'))
-        self._define_payment_method(3, u'Cartão debito'.encode('cp850'))
+        self._define_payment_method(2, u'Cartão credito'.encode('cp850'),
+                                    vinculated=True)
+        self._define_payment_method(3, u'Cartão debito'.encode('cp850'),
+                                    vinculated=True)
         self._define_payment_method(4, u'Financeira'.encode('cp850'))
         self._define_payment_method(5, u'Vale compra'.encode('cp850'))
         for code in range(6, 15):
@@ -467,15 +768,13 @@
 
     def print_status(self):
         status = self._get_status()
-        print 'Flags'
         for flag in reversed(_status_flags):
             if status & flag:
                 print flag, _flagnames[flag]
 
-        print 'non-fiscal registers'
         for i in range(15):
             try:
-                print self._send_command(
+                self._send_command(
                     'LeNaoFiscal', CodNaoFiscal=i)
             except DriverError, e:
                 if e.code != 8057:
@@ -501,10 +800,15 @@
         customer = self._customer_name
         document = self._customer_document
         address = self._customer_address
-        self._send_command('AbreCupomFiscal',
-                           EnderecoConsumidor=address[:80],
-                           IdConsumidor=document[:29],
-                           NomeConsumidor=customer[:30])
+        if self._customer_name:
+            ret = self._send_command('AbreCupomFiscal', EnderecoConsumidor=address[:80],
+                                     IdConsumidor=document[:29], NomeConsumidor=customer[:30])
+        else:
+            ret = self._send_command('AbreCupomFiscal')
+
+        if not ret:
+            return True
+        return False
 
     def coupon_add_item(self, code, description, price, taxcode,
                         quantity=Decimal("1.0"), unit=UnitType.EMPTY,
@@ -519,7 +823,19 @@
         else:
             unit = self._consts.get_value(unit)
 
-        taxcode = int(taxcode)
+        try:
+            taxcode = int(taxcode)
+        except:
+            #print self._get_taxes()
+            taxcode = 1
+#            for x in self._get_taxes():
+#                print '*', taxcode, '*'
+#                if taxcode == x[0]:
+#                    taxcode = int(x[1])
+#                    if taxcode > 9:
+#                        taxcode = 1
+#                    break 
+            
         self._send_command('VendeItem',
                            CodAliquota=taxcode,
                            CodProduto=code[:48],
@@ -527,17 +843,45 @@
                            Unidade=unit,
                            PrecoUnitario=price,
                            Quantidade=quantity)
-        return self._get_last_item_id()
+        retval = self._get_last_item_id()
+        if discount > 0:
+            self._send_command('AcresceItemFiscal',
+                               Cancelar=False, 
+                               NumItem=retval,
+                               ValorAcrescimo=discount * -1)
+        if surcharge > 0:
+            self._send_command('AcresceItemFiscal',
+                               Cancelar=False, 
+                               NumItem=retval,
+                               ValorAcrescimo=surcharge)
+        
+        return retval
 
-    def coupon_cancel_item(self, item_id):
-        self._send_command('CancelaItemFiscal', NumItem=item_id)
+    def desc_acres_item(self, desc_acres, item, valor):
+        if desc_acres == 'D':
+            valor *= -1
+        valor = Decimal(valor).quantize(TWOPLACES)
+        self._send_command('AcresceItemFiscal',
+                           Cancelar=False,
+                           NumItem=item,
+                           ValorAcrescimo=valor)
+        return True
+
+
+    def coupon_cancel_item(self, item_id=None):
+        if item_id == None: # cancela o ultimo item
+            self._send_command('CancelaItemFiscal')
+        else:
+            self._send_command('CancelaItemFiscal', NumItem=item_id)
 
     def coupon_cancel(self):
         self._send_command('CancelaCupom')
+        self.get_corta_papel()
 
     def cancel_last_coupon(self):
         """Cancel the last non fiscal coupon or the last sale."""
         self._send_command('CancelaCupom')
+        self.get_corta_papel()
 
     def coupon_totalize(self, discount=currency(0),
                         surcharge=currency(0), taxcode=TaxType.NONE):
@@ -553,20 +897,67 @@
         return self._get_coupon_total_value()
 
     def coupon_add_payment(self, payment_method, value, description=u""):
+        #pm = int(payment_method)
         pm = int(payment_method)
         self._send_command('PagaCupom',
                            CodMeioPagamento=pm, Valor=value,
                            TextoAdicional=description[:80])
         return self._get_coupon_remainder_value()
 
+    def _add_voucher(self, type, value, cod_finalizadora=-2):
+        '''
+        Recarga de celular
+        cod_finalizadora = -2(Dinheiro por defalt)
+        :type = codigo do tot. nao fiscal
+        '''
+        status = self._get_status()
+        if status & FLAG_DOCUMENTO_ABERTO:
+            self.coupon_cancel()
+        self._send_command('AbreCupomNaoFiscal')
+        self._send_command('EmiteItemNaoFiscal',
+                           CodNaoFiscal=type,
+                           Valor=value)
+        self._send_command('PagaCupom',
+                           CodMeioPagamento=cod_finalizadora, Valor=value)
+        self._send_command('EncerraDocumento')
+        self.get_corta_papel()
+
+    def _configure_payment_methods(self, descricao):
+        vlr = self.get_payment_constants()
+        try:
+            return vlr[descricao[:80]]
+        except KeyError:
+            return False
+
     def coupon_close(self, message=''):
+        max = 8
+        inc = 1
+        new_message = ''
+        opr=''
+        for m in message.split('\n'):
+            if inc <= max:
+                if m.startswith('OP'):
+                    opr = m[4:]
+                else:
+                    new_message += '%s\n' % m
+                    inc += 1
+        new_message = re.sub(r'NOTA LEGAL:', r'\x1BE1NOTA LEGAL:\x1BE0', new_message)
+
         self._send_command('EncerraDocumento',
-                           TextoPromocional=message[:492])
+                           Operador=opr,
+                           TextoPromocional=new_message[:492])
         self._reset()
+        self.get_corta_papel()
         return self.get_coo()
 
     def summarize(self):
         self._send_command('EmiteLeituraX')
+        coo = False
+        while True:
+            coo = self.get_coo()
+            if coo:
+                break
+        self.get_corta_papel()
 
     def close_till(self, previous_day=False):
         status = self._get_status()
@@ -574,44 +965,69 @@
             self.coupon_cancel()
 
         self._send_command('EmiteReducaoZ')
+        self.get_corta_papel()
 
-    def till_add_cash(self, value):
+    def till_add_cash(self, value, totalizador=0, meio=0):
         status = self._get_status()
         if status & FLAG_DOCUMENTO_ABERTO:
             self.coupon_cancel()
         self._send_command('AbreCupomNaoFiscal')
         self._send_command('EmiteItemNaoFiscal',
-                           NomeNaoFiscal="Suprimento",
+                           CodNaoFiscal=totalizador,
                            Valor=value)
         self._send_command('PagaCupom',
                            CodMeioPagamento=-2, Valor=value)
         self._send_command('EncerraDocumento')
+        self.get_corta_papel()
 
-    def till_remove_cash(self, value):
+    def till_remove_cash(self, value, cod=0, text=''):
         status = self._get_status()
         if status & FLAG_DOCUMENTO_ABERTO:
             self.coupon_cancel()
+
         self._send_command('AbreCupomNaoFiscal')
         self._send_command('EmiteItemNaoFiscal',
-                           NomeNaoFiscal="Sangria",
+                           CodNaoFiscal=cod,
                            Valor=value)
-        self._send_command('EncerraDocumento')
+        self._send_command('EncerraDocumento', TextoPromocional=text)
+        self.get_corta_papel()
 
-    def till_read_memory(self, start=None, end=None):
+    def till_read_memory(self, start=None, end=None, full=False, destino='I'):
         try:
             self._send_command('EmiteLeituraMF',
-                               LeituraSimplificada=True,
+                               Destino=destino,
+                               LeituraSimplificada=not full,
                                DataInicial=start,
                                DataFinal=end)
+            if destino == 'I': # impressora
+                self.get_corta_papel()
+            else: # serial
+                return self._le_impressao()
+
         except DriverError, e:
             if e.code == 8089:
                 return
 
-    def till_read_memory_by_reductions(self, start=None, end=None):
+
+    def till_read_memory_by_reductions(self, start=None, end=None, full=False, destino='I'):
+        '''
+        :param destino: I = impressora, S = serial
+        '''
         self._send_command('EmiteLeituraMF',
-                           LeituraSimplificada=True,
+                           Destino=destino,
+                           LeituraSimplificada=not full,
                            ReducaoInicial=start,
                            ReducaoFinal=end)
+        if destino == 'I':
+            self.get_corta_papel()
+        else:
+            return self._le_impressao()
+
+    def till_read_memory_to_serial(self, start=None, end=None, full=False):
+        return self.till_read_memory(start, end, full, 'S')
+
+    def till_read_memory_by_reductions_to_serial(self, start=None, end=None, full=False):
+        return self.till_read_memory_by_reductions(start, end, full, 'S')
 
     def get_capabilities(self):
         return dict(item_code=Capability(max_len=48),
@@ -672,9 +1088,9 @@
         return constants
 
     def get_payment_constants(self):
-        constants = [('-2', 'Dinheiro')]
+        constants = [('Dinheiro', '-2')]
 
-        for reg in range(16):
+        for reg in range(15):
             try:
                 retdict = self._send_command(
                     'LeMeioPagamento', CodMeioPagamentoProgram=reg)
@@ -685,9 +1101,9 @@
 
             code = retdict['CodMeioPagamentoProgram']
             name = retdict['NomeMeioPagamento']
-            constants.append((code, name))
+            constants.append((name.decode(self.coupon_printer_charset), code))
 
-        return constants
+        return dict(constants)
 
     def get_ccf(self):
         return self._read_register('CCF', int)
@@ -703,10 +1119,53 @@
 
     def get_crz(self):
         return self._read_register('CRZ', int)
+    ###
+    def get_gnf(self):
+        return self._read_register('GNF', int)
+
+    def get_cfc(self):
+        return self._read_register('CFC', int)
+
+    def get_grg(self):
+        return self._read_register('GRG', int)
+
+    def get_cdc(self):
+        return self._read_register('CDC', int)
+
 
     def get_firmware_version(self):
         return self._read_register('VersaoSW', str)
 
+    def get_date_last_mov_rz(self):
+        '''
+        :return: Retorna a data do movimento da ultima reducao Z emitida
+        '''
+        ultimo_z = self.get_ultamo_z()
+        data = ''
+        if ultimo_z:
+            data = ultimo_z[582:588] # data do movimento do ultimo Z emitido
+        try:
+            if len(data) == 5:
+                data = '0' + data
+
+            data = datetime.datetime(year=2000 + int(data[4:6]),
+                            month=int(data[2:4]),
+                            day=int(data[:2])).date()
+        except Exception as e:
+            log.error('get_date_last_mov_rz: %s' % str(e))
+            data = 0
+
+        return data
+
+    def get_ultamo_z(self):
+        '''
+        Pega os dados da ultima reducao Z emiditda
+        :return:
+        '''
+        dados_z = self._read_register('DadosUltimaReducaoZ', str)
+
+        return dados_z
+
     def get_sintegra(self):
         data = Settable(
             opening_date=self._read_register('DataAbertura', datetime.date),
